package cn.estsh.i3plus.ext.mes.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesCraftRouteDetailService;
import cn.estsh.i3plus.ext.mes.apiservice.config.AuthUtilExt;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesCraftRouteDetail;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Api(description = "工艺路线明细")
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/mesCraftRouteDetail")
public class MesCraftRouteDetailController extends BaseMesController<MesCraftRouteDetail> {

    @Autowired
    private IMesCraftRouteDetailService mesCraftRouteDetailService;

    @PostMapping(value = "/insert-batch")
    @ApiOperation(value = "批量新增")
    public ResultBean insertMesCraftRouteDetailBatch(@RequestBody List<MesCraftRouteDetail> mesCraftRouteDetailList) {
        try {
            mesCraftRouteDetailService.insertMesCraftRouteDetailBatch(mesCraftRouteDetailList);
            return ResultBean.success("新增成功")
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException e) {
            return ResultBean.fail(e).build();
        } catch (Exception e) {
            return ResultBean.fail(e);
        }
    }

    @PostMapping(value = "/update-batch")
    @ApiOperation(value = "批量修改")
    public ResultBean updateMesCraftRouteDetailBatch(@RequestBody List<MesCraftRouteDetail> mesCraftRouteDetailList) {
        try {
            mesCraftRouteDetailService.updateMesCraftRouteDetailBatch(mesCraftRouteDetailList);
            return ResultBean.success("修改成功")
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException e) {
            return ResultBean.fail(e).build();
        } catch (Exception e) {
            return ResultBean.fail(e);
        }
    }

    @PostMapping(value = "/delete-batch")
    @ApiOperation(value = "批量删除")
    public ResultBean deleteMesCraftRouteDetailBatch(String craftRouteCode) {
        try {
            String organizeCode = AuthUtilExt.getOrganizeCode();
            String userName = AuthUtilExt.getUserName();
            mesCraftRouteDetailService.deleteMesCraftRouteDetailBatch(organizeCode, userName, craftRouteCode);
            return ResultBean.success("新增成功")
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException e) {
            return ResultBean.fail(e).build();
        } catch (Exception e) {
            return ResultBean.fail(e);
        }
    }
}
