package cn.estsh.i3plus.ext.mes.apiservice.controller.busi;

import cn.estsh.i3plus.ext.mes.api.busi.IMaximoService;
import cn.estsh.i3plus.ext.mes.pojo.model.MaximoParamModel;
import cn.estsh.impp.framework.base.controller.MesBaseController;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;


@RestController
@RequestMapping("/white/maximo")
@Api(description = "白名单接口maximo")
public class MesWhiteListController extends MesBaseController {

    @Autowired
    private IMaximoService maximoService;

    @PostMapping(value = "/meter/main-data")
    @ApiOperation(value = "Maximo仪表主数据", notes = "Maximo仪表主数据")
    public Map doMeterMainData(@RequestBody MaximoParamModel paramModel) {
        // 数据校验
        ValidatorBean.checkNotNull(paramModel.getMeterName(), "meterName不能为空");
        ValidatorBean.checkNotNull(paramModel.getAssetNum(), "assetNum不能为空");
        ValidatorBean.checkNotNull(paramModel.getBaseMeasureUnitId(), "baseMeasureUnitId不能为空");
        ValidatorBean.checkNotNull(paramModel.getSiteId(), "siteId不能为空");
        Map resultMap =  maximoService.doMeterMainData(paramModel);

        LOGGER.info("Maximo仪表主数据 返回 resultMap:{}", resultMap);

        return resultMap;

    }

    @PostMapping(value = "/asset/main-data")
    @ApiOperation(value = "Maximo设备主数据", notes = "Maximo设备主数据")
    public Map doAssetMainData(@RequestBody MaximoParamModel paramModel) {
        // 数据校验
        ValidatorBean.checkNotNull(paramModel.getAssetNum(), "assetNum不能为空");
        ValidatorBean.checkNotNull(paramModel.getDescription(), "description不能为空");
        ValidatorBean.checkNotNull(paramModel.getSiteId(), "siteId不能为空");
        ValidatorBean.checkNotNull(paramModel.getStatus(), "status不能为空");
        ValidatorBean.checkNotNull(paramModel.getFailureCode(), "failureCode不能为空");
        Map resultMap =  maximoService.doAssetMainData(paramModel);

        LOGGER.info("Maximo设备主数据 返回 resultMap:{}", resultMap);

        return resultMap;
//        return ResultBean.success().setResultMap(resultMap).setSuccess((Boolean) resultMap.get("success"));

    }

}
