package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.busi.IEquipmentExtService;
import cn.estsh.i3plus.mes.api.iservice.base.IEnumService;
import cn.estsh.i3plus.mes.apiservice.dao.IEquipmentDao;
import cn.estsh.i3plus.mes.apiservice.serviceimpl.busi.CommonService;
import cn.estsh.i3plus.mes.apiservice.serviceimpl.busi.EquipmentService;
import cn.estsh.i3plus.platform.common.convert.ConvertBean;
import cn.estsh.i3plus.platform.common.exception.ImppExceptionEnum;
import cn.estsh.i3plus.platform.common.tool.TimeTool;
import cn.estsh.i3plus.platform.common.util.MesConstWords;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.common.PagerHelper;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.enumutil.MesEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesEquipment;
import cn.estsh.i3plus.pojo.mes.bean.MesWcEquipment;
import cn.estsh.i3plus.pojo.mes.model.MesEquipmentModel;
import cn.estsh.i3plus.pojo.mes.repository.MesEquipmentRepository;
import cn.estsh.i3plus.pojo.mes.repository.MesWcEquipmentRepository;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.LocaleUtils;
import lombok.extern.slf4j.Slf4j;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;
import org.springframework.util.StringUtils;

import java.util.*;
import java.util.stream.Collectors;

/**
 * @Description : mes设备管理方法调度类
 * @Reference :
 * @Author : wangjie
 * @CreateDate : 2019-08-26
 * @Modify:
 **/
@Slf4j
@Service
public class EquipmentExtService implements IEquipmentExtService {
    public static final Logger LOGGER = LoggerFactory.getLogger(EquipmentService.class);

    @Autowired
    private IEquipmentDao equipmentDao;

    @Autowired
    private IEnumService enumService;
    /**
     * 按条件分页查询mes设备台账-组织模型
     *
     * @param mesEquipment
     * @param pager
     */
    @Override
    public ListPager<MesEquipmentModel> queryMesEquipmentByPagerOrg(MesEquipment mesEquipment, Pager pager) {
        Map<String, String> equStatusEnumMap = enumService.getEnumLangeuageKeyByClazzEnum(MesEnumUtil.MES_EQUIPMENT_STATUS.class);
        pager = PagerHelper.getPager(pager, equipmentDao.queryMesEquipmentByPagerOrgCount(mesEquipment));
        List<MesEquipmentModel> equipmentModels = equipmentDao.queryMesEquipmentByPagerOrg(mesEquipment, pager);
        for (MesEquipmentModel equipmentModel : equipmentModels) {
            if(equipmentModel.getStatus() != null){
                equipmentModel.setStatusName(LocaleUtils.getLocaleRes(equStatusEnumMap.get(equipmentModel.getStatus().toString())));
            }
        }
        return new ListPager(equipmentModels, pager);
    }

}
