package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesCarSeriesDetailService;
import cn.estsh.i3plus.platform.common.exception.ImppExceptionEnum;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesCarSeriesDetail;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

@Service
@Slf4j
public class MesCarSeriesDetailService extends BaseMesService<MesCarSeriesDetail> implements IMesCarSeriesDetailService {


    protected void onInsertBean(MesCarSeriesDetail item) {
        // 数据校验
        ValidatorBean.checkNotNull(item.getCarSeriesCode(), "车系代码不能为空");
        ValidatorBean.checkNotNull(item.getCarModelCode(), "车型代码不能为空");
        ValidatorBean.checkNotNull(item.getCarModelName(), "车型名称不能为空");


//        DdlPackBean seriesPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
//        DdlPreparedPack.getStringEqualPack(item.getCarSeriesCode(), "carSeriesCode", seriesPackBean);
//        DdlPreparedPack.getStringEqualPack(item.getCustomerCode(), "customerCode", seriesPackBean);
//        boolean flg = baseRDao.isExitByHql(seriesPackBean);
//        if (flg) {
//            throw ImppExceptionBuilder.newInstance()
//                    .setSystemID(CommonEnumUtil.SOFT_TYPE.MES.getCode())
//                    .setErrorCode(ImppExceptionEnum.VARIFY_EXCEPTION.getCode())
//                    .setErrorDetail("【%s】车系代码【%s】客户代码已经存在，请检查数据", item.getCarSeriesCode(), item.getCustomerCode())
//                    .build();
//        }

    }

    protected void onUpdateBean(MesCarSeriesDetail item) {
        // 数据校验
        ValidatorBean.checkNotNull(item.getCarSeriesCode(), "车系代码不能为空");
        ValidatorBean.checkNotNull(item.getCarModelCode(), "车型代码不能为空");
        ValidatorBean.checkNotNull(item.getCarModelName(), "车型名称不能为空");

//        DdlPackBean seriesPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
//        DdlPreparedPack.getStringEqualPack(item.getCarSeriesCode(), "carSeriesCode", seriesPackBean);
//        DdlPreparedPack.getStringEqualPack(item.getCustomerCode(), "customerCode", seriesPackBean);
//        DdlPreparedPack.getNumNOEqualPack(item.getId(), "id", seriesPackBean);
//        boolean flg = baseRDao.isExitByHql(seriesPackBean);
//        if (flg) {
//            throw ImppExceptionBuilder.newInstance()
//                    .setSystemID(CommonEnumUtil.SOFT_TYPE.MES.getCode())
//                    .setErrorCode(ImppExceptionEnum.VARIFY_EXCEPTION.getCode())
//                    .setErrorDetail("【%s】车系代码【%s】客户代码已经存在，请检查数据", item.getCarSeriesCode(), item.getCustomerCode())
//                    .build();
//        }
    }

    protected void setPackQueryBean(MesCarSeriesDetail bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringLikerPack(bean.getCarSeriesCode(), "carSeriesCode", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getCarSeriesName(), "carSeriesName", packBean);
    }

}
