package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesCavityGroupCfgService;
import cn.estsh.i3plus.ext.mes.apiservice.unit.exception.MesException;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesCavityGroupCfg;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * @Description : 腔组维护
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/5/14 14:05
 * @Modify:
 **/
@Service
@Slf4j
public class MesCavityGroupCfgServiceImpl extends BaseMesService<MesCavityGroupCfg> implements IMesCavityGroupCfgService {

    protected void setPackQueryBean(MesCavityGroupCfg bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringLikerPack(bean.getCavityCode(), "cavityCode", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getCavityName(), "cavityName", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getEquipmentCode(), "equipmentCode", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getEquipmentName(), "equipmentName", packBean);
        packBean.setOrderByStr(" order by createDatetime desc ");
    }

    protected void onInsertBean(MesCavityGroupCfg item) {
        // 数据校验
        ValidatorBean.checkNotNull(item.getCavityCode(), "腔组代码不能为空");

        DdlPackBean packBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getCavityCode(), "cavityCode", packBean);
        boolean flg = baseRDao.isExitByHql(packBean);
        if (flg) {
            MesException.throwMesBusiException("腔组代码【%s】已经存在，请检查数据", item.getCavityCode());
        }
    }

    protected void onUpdateBean(MesCavityGroupCfg item) {
        // 数据校验
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getCavityCode(), "cavityCode", packBean);

        DdlPreparedPack.getNumNOEqualPack(item.getId(), "id", packBean);
        boolean flg = baseRDao.isExitByHql(packBean);
        if (flg) {
            MesException.throwMesBusiException("腔组代码【%s】已经存在，请检查数据", item.getCavityCode());
        }
    }


}
