package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesPartService;
import cn.estsh.i3plus.ext.mes.apiservice.unit.exception.MesException;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesPart;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

@Service
@Slf4j
public class MesPartService extends BaseMesService<MesPart> implements IMesPartService {

    protected void setPackQueryBean(MesPart bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringEqualPack(bean.getPartNo(), "partNo", packBean);
        DdlPreparedPack.getStringLikeEqualPack(bean.getPartName(), "partName", packBean);

    }

    @Override
    public MesPart getPartByPartNo(String partNo, String organizeCode) {
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(partNo, "partNo", ddlPackBean);
        MesPart mesPart = baseRDao.getByProperty(ddlPackBean);
        if (null == mesPart) {
            MesException.throwMesBusiException("物料【%s】信息不存在", partNo);
        }
        return mesPart;
    }
}
