package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.ext.mes.api.busi.IMaximoService;
import cn.estsh.i3plus.ext.mes.pojo.model.MaximoParamModel;
import cn.estsh.i3plus.platform.common.convert.ConvertBean;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesMaximoAssetMainData;
import cn.estsh.i3plus.pojo.mes.bean.MesMaximoMeterMainData;
import cn.estsh.i3plus.pojo.mes.repository.IMesMaximoAssetMainDataRepository;
import cn.estsh.i3plus.pojo.mes.repository.IMesMaximoMeterMainDataRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

/**
 * @Description : MaximoServiceImpl
 * @Author :gsz
 * @Date 2024/5/15 13:17
 * @Modify
 **/
@Service
public class MaximoServiceImpl implements IMaximoService {

    private static final Logger LOGGER = LoggerFactory.getLogger(MaximoServiceImpl.class);

    @Autowired
    private IMesMaximoAssetMainDataRepository maximoAssetMainDataRDao;

    @Autowired
    private IMesMaximoMeterMainDataRepository maximoMeterMainDataRDao;


    @Override
    public Map doMeterMainData(MaximoParamModel paramModel) {

        Map resultMap = new HashMap();
        DdlPackBean roadPackBean = DdlPackBean.getDdlPackBean(paramModel.getSiteId());
        DdlPreparedPack.getStringEqualPack(paramModel.getMeterName(), "meterName", roadPackBean);
        DdlPreparedPack.getStringEqualPack(paramModel.getAssetNum(), "assetNum", roadPackBean);
        DdlPreparedPack.getStringEqualPack(paramModel.getBaseMeasureUnitId(), "baseMeasureUnitId", roadPackBean);
        boolean flg = maximoMeterMainDataRDao.isExitByHql(roadPackBean);
        if (flg) {
            resultMap.put("success",false);
            String message ="仪表编号"+paramModel.getMeterName()+"设备编号"+paramModel.getMeterName()+"数据已经存在，请检查数据";
            resultMap.put("message",message);
            return  resultMap;
        }
        try {
            MesMaximoMeterMainData maximoMeterMainData = new MesMaximoMeterMainData();
            maximoMeterMainData.setOrganizeCode(paramModel.getSiteId());
            maximoMeterMainData.setMeterName(paramModel.getMeterName());
            maximoMeterMainData.setAssetNum(paramModel.getAssetNum());
            maximoMeterMainData.setBaseMeasureUnitId(paramModel.getBaseMeasureUnitId());
            ConvertBean.serviceModelInitialize(maximoMeterMainData, "doMeterMainData");

            maximoMeterMainDataRDao.save(maximoMeterMainData);

            resultMap.put("success",true);
            resultMap.put("message","成功");
            return  resultMap;
        }catch (Exception e) {
            resultMap.put("success",false);
            resultMap.put("message",e);
            return  resultMap;
        }
    }
    @Override
    public Map doAssetMainData(MaximoParamModel paramModel) {
        /*String url = "http://10.195.88.71:8300/white/maximo/asset/main-data";
        Map<String, String> map = new HashMap<>();
        map.put("assetNum", paramModel.getAssetNum());
        map.put("description", paramModel.getDescription());
        map.put("siteId", paramModel.getSiteId());
        map.put("status", paramModel.getStatus());
        map.put("failureCode", paramModel.getFailureCode());

        String result = HttpClientTool.doHttpUrl(CommonEnumUtil.HTTP_METHOD_TYPE.POST, true, url, map, null, null);

        JSONObject jsonObject = JSON.parseObject(result);*/
        Map resultMap = new HashMap();
        DdlPackBean roadPackBean = DdlPackBean.getDdlPackBean(paramModel.getSiteId());
        DdlPreparedPack.getStringEqualPack(paramModel.getAssetNum(), "assetNum", roadPackBean);
        DdlPreparedPack.getStringEqualPack(paramModel.getDescription(), "description", roadPackBean);
        DdlPreparedPack.getStringEqualPack(paramModel.getStatus(), "status", roadPackBean);
        DdlPreparedPack.getStringEqualPack(paramModel.getFailureCode(), "failureCode", roadPackBean);
        boolean flg = maximoAssetMainDataRDao.isExitByHql(roadPackBean);
        if (flg) {
            resultMap.put("success",false);
            String message ="设备编号"+paramModel.getAssetNum()+
                    "设备名称"+paramModel.getDescription()+
                    "状态"+paramModel.getStatus()+
                    "故障类别"+paramModel.getFailureCode()+"数据已经存在，请检查数据";
            resultMap.put("message",message);
            return  resultMap;
        }
        try {
            MesMaximoAssetMainData maximoAssetMainData = new MesMaximoAssetMainData();
            maximoAssetMainData.setOrganizeCode(paramModel.getSiteId());
            maximoAssetMainData.setAssetNum(paramModel.getAssetNum());
            maximoAssetMainData.setDescription(paramModel.getDescription());
            maximoAssetMainData.setStatus(paramModel.getStatus());
            maximoAssetMainData.setFailureCode(paramModel.getFailureCode());
            ConvertBean.serviceModelInitialize(maximoAssetMainData, "doMeterMainData");

            maximoAssetMainDataRDao.save(maximoAssetMainData);

            resultMap.put("success",true);
            resultMap.put("message","成功");
            return  resultMap;
        }catch (Exception e) {
            resultMap.put("success",false);
            resultMap.put("message",e);
            return  resultMap;
        }
    }
}
